/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by lister-gen. DO NOT EDIT.

package v1beta2

import (
	v1beta2 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_aws/aws/v1beta2"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// AWSMachineLister helps list AWSMachines.
// All objects returned here must be treated as read-only.
type AWSMachineLister interface {
	// List lists all AWSMachines in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta2.AWSMachine, err error)
	// AWSMachines returns an object that can list and get AWSMachines.
	AWSMachines(namespace string) AWSMachineNamespaceLister
	AWSMachineListerExpansion
}

// aWSMachineLister implements the AWSMachineLister interface.
type aWSMachineLister struct {
	indexer cache.Indexer
}

// NewAWSMachineLister returns a new AWSMachineLister.
func NewAWSMachineLister(indexer cache.Indexer) AWSMachineLister {
	return &aWSMachineLister{indexer: indexer}
}

// List lists all AWSMachines in the indexer.
func (s *aWSMachineLister) List(selector labels.Selector) (ret []*v1beta2.AWSMachine, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta2.AWSMachine))
	})
	return ret, err
}

// AWSMachines returns an object that can list and get AWSMachines.
func (s *aWSMachineLister) AWSMachines(namespace string) AWSMachineNamespaceLister {
	return aWSMachineNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// AWSMachineNamespaceLister helps list and get AWSMachines.
// All objects returned here must be treated as read-only.
type AWSMachineNamespaceLister interface {
	// List lists all AWSMachines in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta2.AWSMachine, err error)
	// Get retrieves the AWSMachine from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1beta2.AWSMachine, error)
	AWSMachineNamespaceListerExpansion
}

// aWSMachineNamespaceLister implements the AWSMachineNamespaceLister
// interface.
type aWSMachineNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all AWSMachines in the indexer for a given namespace.
func (s aWSMachineNamespaceLister) List(selector labels.Selector) (ret []*v1beta2.AWSMachine, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta2.AWSMachine))
	})
	return ret, err
}

// Get retrieves the AWSMachine from the indexer for a given namespace and name.
func (s aWSMachineNamespaceLister) Get(name string) (*v1beta2.AWSMachine, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1beta2.Resource("awsmachine"), name)
	}
	return obj.(*v1beta2.AWSMachine), nil
}
